package cpcns.dingZhi.tongYong.service.impl;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cpcns.base.common.util.DataBaseUtil;
import cpcns.dangAnBase.base.service.impl.DangAnBaseServiceImpl;
import cpcns.dingZhi.tongYong.dao.ITongYongDao;
import cpcns.dingZhi.tongYong.service.ItongYongService;
import cpcns.utils.CommStatic;
import cpcns.utils.PagerVO;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.apache.poi.ss.formula.functions.T;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("tongYongService")
public class tongYongServiceImpl extends DangAnBaseServiceImpl<T> implements ItongYongService {
  @Autowired
  private ITongYongDao tongYongnDao;
  
  public PagerVO query_SQL(Integer start, Integer rows, String table, Map<String, Object> map, String orderbysql) throws Exception {
    Map<String, Object> tp = new HashMap<>();
    StringBuffer sql = (new StringBuffer(" select hangBiaoShi,quanZongHao,miJi,biaoTi,guiDangNianDu,dangHao,xuHao,baoGuanQiXian,zeRenZhe from ")).append(table).append(" where 1=1 ");
    if (table.toUpperCase().equals("D_ZHUANYEWENJIAN"))
      sql = (new StringBuffer(" select hangBiaoShi,quanZongHao,miJi,biaoTi,guiDangNianDu,dangHao,xuHao,baoGuanQiXian,zeRenZhe,yeShu,fenShu,fenLeiHao from ")).append(table).append(" where 1=1 "); 
    map.put("zhuangTai_notin", "3,4");
    map.remove("type");
    map.remove("page");
    map.remove("rows");
    Object para = null;
    Iterator<String> it = map.keySet().iterator();
    while (it.hasNext()) {
      String key = it.next();
      para = map.get(key);
      if (key.endsWith("_not")) {
        String keys = key.replaceAll("_not", "");
        sql.append(" and ").append(keys).append(" != :").append(keys);
        tp.put(keys, para);
        continue;
      } 
      if (key.endsWith("_in")) {
        String keys = key.replaceAll("_in", "");
        sql.append(" and ").append(keys).append(" in(:").append(keys).append(")");
        tp.put(key, para);
        continue;
      } 
      if (key.endsWith("_notin")) {
        String keys = key.replaceAll("_notin", "");
        sql.append(" and ").append(keys).append(" not in(:").append(keys).append(")");
        tp.put(key, para);
        continue;
      } 
      if (key.endsWith("_like")) {
        String keys = key.replaceAll("_like", "");
        sql.append(" and ").append(keys).append(" like:").append(keys);
        tp.put(key, "%" + para + "%");
        continue;
      } 
      System.out.println("key值：" + key + " value值：" + map.get(key));
      if (para != null && para != "") {
        sql.append(" and ").append(key).append(" =:").append(key).append("");
        tp.put(key, para);
      } 
    } 
    return this.tongYongnDao.getAll(start.intValue(), rows.intValue(), String.valueOf(sql.toString()) + " " + orderbysql, tp, orderbysql, table);
  }
  
  public String SelectXuHaoSQL(String table, Map<String, Object> map, String orderbysql) throws Exception {
    StringBuffer sql = (new StringBuffer(" select max(xuHao) xuHao from ")).append(table).append(" where 1=1 ");
    Map<String, Object> tp = new HashMap<>();
    map.put("zhuangTai_notin", "3,4");
    Object para = null;
    Iterator<String> it = map.keySet().iterator();
    while (it.hasNext()) {
      String key = it.next();
      para = map.get(key);
      if (key.endsWith("_not")) {
        String keys = key.replaceAll("_not", "");
        sql.append(" and ").append(keys).append(" != :").append(keys);
        tp.put(keys, para);
        continue;
      } 
      if (key.endsWith("_in")) {
        String keys = key.replaceAll("_in", "");
        sql.append(" and ").append(keys).append(" in(:").append(keys).append(")");
        tp.put(key, para);
        continue;
      } 
      if (key.endsWith("_notin")) {
        String keys = key.replaceAll("_notin", "");
        sql.append(" and ").append(keys).append(" not in(:").append(keys).append(")");
        tp.put(key, para);
        continue;
      } 
      System.out.println("key值：" + key + " value值：" + map.get(key));
      if (para != null && para != "") {
        sql.append(" and ").append(key).append(" =:").append(key).append("");
        tp.put(key, para);
      } 
    } 
    return this.tongYongnDao.SelectXuHaoSQL(sql.toString(), tp, orderbysql);
  }
  
  public int checkWenjian(Integer hangBiaoShi, String table) {
    return this.tongYongnDao.checkWenjian(hangBiaoShi, table);
  }
  
  public Integer queryIsNotFile(Integer hangBiaoShi, String table) {
    String sql = "";
    String sqlgl = "";
    if (table.contains("XiangMu")) {
      sql = " select count(*) from " + table.replace("XiangMu", "AnJuan") + " where guanLianBiaoShi = " + hangBiaoShi;
    } else if (table.contains("AnJuan")) {
      sql = " select count(*) from " + table.replace("AnJuan", "") + " where guanLianBiaoShi = " + hangBiaoShi;
      List<String> cols = getTableColumnNames(table);
      if (cols.toString().contains("guanLianBiaoShi")) {
        sqlgl = " select guanLianBiaoShi from " + table + " where hangBiaoShi = " + hangBiaoShi;
        return this.tongYongnDao.isNotGuanLian(sqlgl, table);
      } 
    } else if (!table.contains("XiangMu") && !table.contains("AnJuan")) {
      sqlgl = " select guanLianBiaoShi from " + table + " where hangBiaoShi = " + hangBiaoShi;
      return this.tongYongnDao.isNotGuanLian(sqlgl, table);
    } 
    return this.tongYongnDao.isNotGuanLian(sql, table);
  }
  
  public List<String> getTableColumnNames(String tableName) {
    List<String> columnNames = new ArrayList<>();
    String DBDRIVER = "";
    String IP = "";
    String user = "";
    String mima = "";
    List<Object[]> list = getList("select databaseurl,databasedriver,yonghumingcheng,yonghumima from s_manage where hangBiaoShi=4");
    if (list != null && list.size() > 0) {
      Object[] objects = list.get(0);
      IP = objects[0].toString();
      DBDRIVER = objects[1].toString();
      user = objects[2].toString();
      mima = objects[3].toString();
    } 
    IP = getXiTongDaiMaByMingCheng("23219", 2, IP);
    DBDRIVER = getXiTongDaiMaByMingCheng("23215", 2, DBDRIVER);
    String dataType = DataBaseUtil.getCurSessionDBType(this.tongYongnDao.getSession());
    Connection conn = CommStatic.getConnection_(DBDRIVER, IP, user, mima);
    PreparedStatement pStemt = null;
    String SQL = "SELECT * FROM ";
    String tableSql = String.valueOf(SQL) + tableName;
    try {
      pStemt = conn.prepareStatement(tableSql);
      ResultSetMetaData rsmd = pStemt.getMetaData();
      int size = rsmd.getColumnCount();
      for (int i = 0; i < size; i++)
        columnNames.add(rsmd.getColumnName(i + 1)); 
    } catch (SQLException e) {
      e.printStackTrace();
    } finally {
      if (pStemt != null)
        try {
          pStemt.close();
          conn.close();
        } catch (SQLException e) {
          e.printStackTrace();
        }  
    } 
    return columnNames;
  }
  
  public String queryAjName(Integer hangBiaoShi, String table) {
    return this.tongYongnDao.queryAjName(hangBiaoShi, table);
  }
}
